---
title: 'TypeError: cannot use ''in'' operator to search for ''x'' in ''y'''
slug: Web/JavaScript/Reference/Errors/in_operator_no_object
tags:
  - Error
  - Errors
  - JavaScript
  - TypeError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exception "right-hand side of 'in' should be an object" occurs when the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/in"><code>in</code> operator</a> was used to search in strings, or in numbers, or other primitive types. It can only be used to check if a property is in an object.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox notranslate">TypeError: Invalid operand to 'in' (Edge)
TypeError: right-hand side of 'in' should be an object, got 'x' (Firefox)
TypeError: cannot use 'in' operator to search for 'x' in 'y' (Firefox, Chrome)
</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("TypeError")}}</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>The <a href="/en-US/docs/Web/JavaScript/Reference/Operators/in"><code>in</code> operator</a> can only be used to check if a property is in an object. You can't search in strings, or in numbers, or other primitive types.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Searching_in_strings">Searching in strings</h3>

<p>Unlike in other programming languages (e.g. Python), you can't search in strings using the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/in"><code>in</code> operator</a>.</p>

<pre class="brush: js example-bad notranslate">"Hello" in "Hello World";
// TypeError: cannot use 'in' operator to search for 'Hello' in 'Hello World'</pre>

<p>Instead you will need to use {{jsxref("String.prototype.indexOf()")}}, for example.</p>

<pre class="brush: js example-good notranslate">"Hello World".indexOf("Hello") !== -1;
// true</pre>

<h3 id="The_operand_cant_be_null_or_undefined">The operand can't be null or undefined</h3>

<p>Make sure the object you are inspecting isn't actually {{jsxref("null")}} or {{jsxref("undefined")}}.</p>

<pre class="brush: js example-bad notranslate">var foo = null;
"bar" in foo;
// TypeError: cannot use 'in' operator to search for 'bar' in 'foo' (Chrome)
// TypeError: right-hand side of 'in' should be an object, got null (Firefox)
</pre>

<p>The <code>in</code> operator always expects an object.</p>

<pre class="brush: js example-good notranslate">var foo = { baz: "bar" };
"bar" in foo; // false

"PI" in Math; // true
"pi" in Math; // false
</pre>

<h3 id="Searching_in_arrays">Searching in arrays</h3>

<p>Be careful when using the <code>in</code> operator to search in {{jsxref("Array")}} objects. The <code>in</code> operator checks the index number, not the value at that index.</p>

<pre class="brush: js notranslate">var trees = ['redwood', 'bay', 'cedar', 'oak', 'maple'];
3 in trees; // true
"oak" in trees; // false</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/in"><code>in</code> operator</a></li>
</ul>
